/*
  Register definitions for slave core: Converter board registers

  * File           : conv_regs.h
  * Author         : auto-generated by wbgen2 from .\conv_regs.wb
  * Created        : 09/26/17 10:50:26
  * Standard       : ANSI C

    THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE .\conv_regs.wb
    DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!

*/

#ifndef __WBGEN2_REGDEFS__\CONV_REGS_WB
#define __WBGEN2_REGDEFS__\CONV_REGS_WB

#include <inttypes.h>

#if defined( __GNUC__)
#define PACKED __attribute__ ((packed))
#else
#error "Unsupported compiler?"
#endif

#ifndef __WBGEN2_MACROS_DEFINED__
#define __WBGEN2_MACROS_DEFINED__
#define WBGEN2_GEN_MASK(offset, size) (((1<<(size))-1) << (offset))
#define WBGEN2_GEN_WRITE(value, offset, size) (((value) & ((1<<(size))-1)) << (offset))
#define WBGEN2_GEN_READ(reg, offset, size) (((reg) >> (offset)) & ((1<<(size))-1))
#define WBGEN2_SIGN_EXTEND(value, bits) (((value) & (1<<bits) ? ~((1<<(bits))-1): 0 ) | (value))
#endif


/* definitions for register: BIDR */

/* definitions for register: SR */

/* definitions for field: Gateware version in reg: SR */
#define REG_SR_GWVERS_MASK                    WBGEN2_GEN_MASK(0, 8)
#define REG_SR_GWVERS_SHIFT                   0
#define REG_SR_GWVERS_W(value)                WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_SR_GWVERS_R(reg)                  WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: Status of on-board general-purpose switches in reg: SR */
#define REG_SR_SWITCHES_MASK                  WBGEN2_GEN_MASK(8, 8)
#define REG_SR_SWITCHES_SHIFT                 8
#define REG_SR_SWITCHES_W(value)              WBGEN2_GEN_WRITE(value, 8, 8)
#define REG_SR_SWITCHES_R(reg)                WBGEN2_GEN_READ(reg, 8, 8)

/* definitions for field: RTM detection lines cite{rtm-det} in reg: SR */
#define REG_SR_RTM_MASK                       WBGEN2_GEN_MASK(16, 6)
#define REG_SR_RTM_SHIFT                      16
#define REG_SR_RTM_W(value)                   WBGEN2_GEN_WRITE(value, 16, 6)
#define REG_SR_RTM_R(reg)                     WBGEN2_GEN_READ(reg, 16, 6)

/* definitions for field: Hardware version in reg: SR */
#define REG_SR_HWVERS_MASK                    WBGEN2_GEN_MASK(22, 6)
#define REG_SR_HWVERS_SHIFT                   22
#define REG_SR_HWVERS_W(value)                WBGEN2_GEN_WRITE(value, 22, 6)
#define REG_SR_HWVERS_R(reg)                  WBGEN2_GEN_READ(reg, 22, 6)

/* definitions for field: White Rabbit present in reg: SR */
#define REG_SR_WRPRES                         WBGEN2_GEN_MASK(28, 1)

/* definitions for register: ERR */

/* definitions for field: I2C communication watchdog timeout error in reg: ERR */
#define REG_ERR_I2C_WDTO                      WBGEN2_GEN_MASK(0, 1)

/* definitions for field: I2C communication error in reg: ERR */
#define REG_ERR_I2C_ERR                       WBGEN2_GEN_MASK(1, 1)

/* definitions for field: Frequency error in reg: ERR */
#define REG_ERR_FLIM_PMISSE_MASK              WBGEN2_GEN_MASK(2, 6)
#define REG_ERR_FLIM_PMISSE_SHIFT             2
#define REG_ERR_FLIM_PMISSE_W(value)          WBGEN2_GEN_WRITE(value, 2, 6)
#define REG_ERR_FLIM_PMISSE_R(reg)            WBGEN2_GEN_READ(reg, 2, 6)

/* definitions for field: Frequency watchdog error in reg: ERR */
#define REG_ERR_FWDG_PMISSE_MASK              WBGEN2_GEN_MASK(8, 6)
#define REG_ERR_FWDG_PMISSE_SHIFT             8
#define REG_ERR_FWDG_PMISSE_W(value)          WBGEN2_GEN_WRITE(value, 8, 6)
#define REG_ERR_FWDG_PMISSE_R(reg)            WBGEN2_GEN_READ(reg, 8, 6)

/* definitions for register: CR */

/* definitions for field: Reset unlock bit in reg: CR */
#define REG_CR_RST_UNLOCK                     WBGEN2_GEN_MASK(0, 1)

/* definitions for field: Reset bit - active only if RST_UNLOCK is 1 in reg: CR */
#define REG_CR_RST                            WBGEN2_GEN_MASK(1, 1)

/* definitions for field: Manual Pulse Trigger in reg: CR */
#define REG_CR_MPT_MASK                       WBGEN2_GEN_MASK(2, 8)
#define REG_CR_MPT_SHIFT                      2
#define REG_CR_MPT_W(value)                   WBGEN2_GEN_WRITE(value, 2, 8)
#define REG_CR_MPT_R(reg)                     WBGEN2_GEN_READ(reg, 2, 8)

/* definitions for register: CH1FPPCR */

/* definitions for register: CH2FPPCR */

/* definitions for register: CH3FPPCR */

/* definitions for register: CH4FPPCR */

/* definitions for register: CH5FPPCR */

/* definitions for register: CH6FPPCR */

/* definitions for register: CH1RPPCR */

/* definitions for register: CH2RPPCR */

/* definitions for register: CH3RPPCR */

/* definitions for register: CH4RPPCR */

/* definitions for register: CH5RPPCR */

/* definitions for register: CH6RPPCR */

/* definitions for register: TVLR */

/* definitions for register: TVHR */

/* definitions for register: TBMR */

/* definitions for field: Channel mask in reg: TBMR */
#define REG_TBMR_CHAN_MASK                    WBGEN2_GEN_MASK(0, 6)
#define REG_TBMR_CHAN_SHIFT                   0
#define REG_TBMR_CHAN_W(value)                WBGEN2_GEN_WRITE(value, 0, 6)
#define REG_TBMR_CHAN_R(reg)                  WBGEN2_GEN_READ(reg, 0, 6)

/* definitions for field: White Rabbit present in reg: TBMR */
#define REG_TBMR_WRTAG                        WBGEN2_GEN_MASK(31, 1)

/* definitions for register: TBCYR */

/* definitions for register: TBTLR */

/* definitions for register: TBTHR */

/* definitions for register: TBCSR */

/* definitions for field: Buffer counter in reg: TBCSR */
#define REG_TBCSR_USEDW_MASK                  WBGEN2_GEN_MASK(0, 7)
#define REG_TBCSR_USEDW_SHIFT                 0
#define REG_TBCSR_USEDW_W(value)              WBGEN2_GEN_WRITE(value, 0, 7)
#define REG_TBCSR_USEDW_R(reg)                WBGEN2_GEN_READ(reg, 0, 7)

/* definitions for field: Buffer full in reg: TBCSR */
#define REG_TBCSR_FULL                        WBGEN2_GEN_MASK(16, 1)

/* definitions for field: Buffer empty in reg: TBCSR */
#define REG_TBCSR_EMPTY                       WBGEN2_GEN_MASK(17, 1)

/* definitions for field: Clear tag buffer in reg: TBCSR */
#define REG_TBCSR_CLR                         WBGEN2_GEN_MASK(18, 1)

/* definitions for register: CH1LTSCYR */

/* definitions for register: CH1LTSTLR */

/* definitions for register: CH1LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH1LTSTHR */
#define REG_CH1LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH1LTSTHR_TAI_SHIFT               0
#define REG_CH1LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH1LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH1LTSTHR */
#define REG_CH1LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: CH2LTSCYR */

/* definitions for register: CH2LTSTLR */

/* definitions for register: CH2LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH2LTSTHR */
#define REG_CH2LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH2LTSTHR_TAI_SHIFT               0
#define REG_CH2LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH2LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH2LTSTHR */
#define REG_CH2LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: CH3LTSCYR */

/* definitions for register: CH3LTSTLR */

/* definitions for register: CH3LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH3LTSTHR */
#define REG_CH3LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH3LTSTHR_TAI_SHIFT               0
#define REG_CH3LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH3LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH3LTSTHR */
#define REG_CH3LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: CH4LTSCYR */

/* definitions for register: CH4LTSTLR */

/* definitions for register: CH4LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH4LTSTHR */
#define REG_CH4LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH4LTSTHR_TAI_SHIFT               0
#define REG_CH4LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH4LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH4LTSTHR */
#define REG_CH4LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: CH5LTSCYR */

/* definitions for register: CH5LTSTLR */

/* definitions for register: CH5LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH5LTSTHR */
#define REG_CH5LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH5LTSTHR_TAI_SHIFT               0
#define REG_CH5LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH5LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH5LTSTHR */
#define REG_CH5LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: CH6LTSCYR */

/* definitions for register: CH6LTSTLR */

/* definitions for register: CH6LTSTHR */

/* definitions for field: Upper part of TAI seconds counter in reg: CH6LTSTHR */
#define REG_CH6LTSTHR_TAI_MASK                WBGEN2_GEN_MASK(0, 8)
#define REG_CH6LTSTHR_TAI_SHIFT               0
#define REG_CH6LTSTHR_TAI_W(value)            WBGEN2_GEN_WRITE(value, 0, 8)
#define REG_CH6LTSTHR_TAI_R(reg)              WBGEN2_GEN_READ(reg, 0, 8)

/* definitions for field: White Rabbit present in reg: CH6LTSTHR */
#define REG_CH6LTSTHR_WRTAG                   WBGEN2_GEN_MASK(31, 1)

/* definitions for register: LSR */

/* definitions for field: Front panel channel input state in reg: LSR */
#define REG_LSR_FRONT_MASK                    WBGEN2_GEN_MASK(0, 6)
#define REG_LSR_FRONT_SHIFT                   0
#define REG_LSR_FRONT_W(value)                WBGEN2_GEN_WRITE(value, 0, 6)
#define REG_LSR_FRONT_R(reg)                  WBGEN2_GEN_READ(reg, 0, 6)

/* definitions for field: Front panel INV-TTL input state in reg: LSR */
#define REG_LSR_FRONTINV_MASK                 WBGEN2_GEN_MASK(6, 4)
#define REG_LSR_FRONTINV_SHIFT                6
#define REG_LSR_FRONTINV_W(value)             WBGEN2_GEN_WRITE(value, 6, 4)
#define REG_LSR_FRONTINV_R(reg)               WBGEN2_GEN_READ(reg, 6, 4)

/* definitions for field: Rear panel input state in reg: LSR */
#define REG_LSR_REAR_MASK                     WBGEN2_GEN_MASK(10, 6)
#define REG_LSR_REAR_SHIFT                    10
#define REG_LSR_REAR_W(value)                 WBGEN2_GEN_WRITE(value, 10, 6)
#define REG_LSR_REAR_R(reg)                   WBGEN2_GEN_READ(reg, 10, 6)

/* definitions for field: Front panel input failsafe state in reg: LSR */
#define REG_LSR_FRONTFS_MASK                  WBGEN2_GEN_MASK(16, 6)
#define REG_LSR_FRONTFS_SHIFT                 16
#define REG_LSR_FRONTFS_W(value)              WBGEN2_GEN_WRITE(value, 16, 6)
#define REG_LSR_FRONTFS_R(reg)                WBGEN2_GEN_READ(reg, 16, 6)

/* definitions for field: Front panel inverter input failsafe state in reg: LSR */
#define REG_LSR_FRONTINVFS_MASK               WBGEN2_GEN_MASK(22, 4)
#define REG_LSR_FRONTINVFS_SHIFT              22
#define REG_LSR_FRONTINVFS_W(value)           WBGEN2_GEN_WRITE(value, 22, 4)
#define REG_LSR_FRONTINVFS_R(reg)             WBGEN2_GEN_READ(reg, 22, 4)

/* definitions for field: Rear panel input failsafe state in reg: LSR */
#define REG_LSR_REARFS_MASK                   WBGEN2_GEN_MASK(26, 6)
#define REG_LSR_REARFS_SHIFT                  26
#define REG_LSR_REARFS_W(value)               WBGEN2_GEN_WRITE(value, 26, 6)
#define REG_LSR_REARFS_R(reg)                 WBGEN2_GEN_READ(reg, 26, 6)

/* definitions for register: OSWR */

/* definitions for field: Switch state in reg: OSWR */
#define REG_OSWR_SWITCHES_MASK                WBGEN2_GEN_MASK(0, 32)
#define REG_OSWR_SWITCHES_SHIFT               0
#define REG_OSWR_SWITCHES_W(value)            WBGEN2_GEN_WRITE(value, 0, 32)
#define REG_OSWR_SWITCHES_R(reg)              WBGEN2_GEN_READ(reg, 0, 32)

/* definitions for register: UIDLR */

/* definitions for register: UIDHR */

/* definitions for register: TEMPR */

PACKED struct REG_WB {
  /* [0x0]: REG BIDR */
  uint32_t BIDR;
  /* [0x4]: REG SR */
  uint32_t SR;
  /* [0x8]: REG ERR */
  uint32_t ERR;
  /* [0xc]: REG CR */
  uint32_t CR;
  /* [0x10]: REG CH1FPPCR */
  uint32_t CH1FPPCR;
  /* [0x14]: REG CH2FPPCR */
  uint32_t CH2FPPCR;
  /* [0x18]: REG CH3FPPCR */
  uint32_t CH3FPPCR;
  /* [0x1c]: REG CH4FPPCR */
  uint32_t CH4FPPCR;
  /* [0x20]: REG CH5FPPCR */
  uint32_t CH5FPPCR;
  /* [0x24]: REG CH6FPPCR */
  uint32_t CH6FPPCR;
  /* [0x28]: REG CH1RPPCR */
  uint32_t CH1RPPCR;
  /* [0x2c]: REG CH2RPPCR */
  uint32_t CH2RPPCR;
  /* [0x30]: REG CH3RPPCR */
  uint32_t CH3RPPCR;
  /* [0x34]: REG CH4RPPCR */
  uint32_t CH4RPPCR;
  /* [0x38]: REG CH5RPPCR */
  uint32_t CH5RPPCR;
  /* [0x3c]: REG CH6RPPCR */
  uint32_t CH6RPPCR;
  /* [0x40]: REG TVLR */
  uint32_t TVLR;
  /* [0x44]: REG TVHR */
  uint32_t TVHR;
  /* [0x48]: REG TBMR */
  uint32_t TBMR;
  /* [0x4c]: REG TBCYR */
  uint32_t TBCYR;
  /* [0x50]: REG TBTLR */
  uint32_t TBTLR;
  /* [0x54]: REG TBTHR */
  uint32_t TBTHR;
  /* [0x58]: REG TBCSR */
  uint32_t TBCSR;
  /* [0x5c]: REG CH1LTSCYR */
  uint32_t CH1LTSCYR;
  /* [0x60]: REG CH1LTSTLR */
  uint32_t CH1LTSTLR;
  /* [0x64]: REG CH1LTSTHR */
  uint32_t CH1LTSTHR;
  /* [0x68]: REG CH2LTSCYR */
  uint32_t CH2LTSCYR;
  /* [0x6c]: REG CH2LTSTLR */
  uint32_t CH2LTSTLR;
  /* [0x70]: REG CH2LTSTHR */
  uint32_t CH2LTSTHR;
  /* [0x74]: REG CH3LTSCYR */
  uint32_t CH3LTSCYR;
  /* [0x78]: REG CH3LTSTLR */
  uint32_t CH3LTSTLR;
  /* [0x7c]: REG CH3LTSTHR */
  uint32_t CH3LTSTHR;
  /* [0x80]: REG CH4LTSCYR */
  uint32_t CH4LTSCYR;
  /* [0x84]: REG CH4LTSTLR */
  uint32_t CH4LTSTLR;
  /* [0x88]: REG CH4LTSTHR */
  uint32_t CH4LTSTHR;
  /* [0x8c]: REG CH5LTSCYR */
  uint32_t CH5LTSCYR;
  /* [0x90]: REG CH5LTSTLR */
  uint32_t CH5LTSTLR;
  /* [0x94]: REG CH5LTSTHR */
  uint32_t CH5LTSTHR;
  /* [0x98]: REG CH6LTSCYR */
  uint32_t CH6LTSCYR;
  /* [0x9c]: REG CH6LTSTLR */
  uint32_t CH6LTSTLR;
  /* [0xa0]: REG CH6LTSTHR */
  uint32_t CH6LTSTHR;
  /* [0xa4]: REG LSR */
  uint32_t LSR;
  /* [0xa8]: REG OSWR */
  uint32_t OSWR;
  /* [0xac]: REG UIDLR */
  uint32_t UIDLR;
  /* [0xb0]: REG UIDHR */
  uint32_t UIDHR;
  /* [0xb4]: REG TEMPR */
  uint32_t TEMPR;
};

#endif
